aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorArvind Sankar <[email protected]>2020-07-18 21:24:48 -0400
committerBrian Behlendorf <[email protected]>2020-07-22 10:00:40 -0700
commit59415fc9fba4796d832b1a82b5ac338df7a11510 (patch)
tree916de7492292707cc9b15614c2a9d31f7784924f
parentd32a59fe2b29a7008a820d597a7efa41ccdf2f09 (diff)
Add zfs_gitrev.h to the distributed sources
Commit 109d2c931020 ("Move zfs_gitrev.h to build directory") stopped distributing zfs_gitrev.h, as it is a generated file. Add it back, with some changes in behavior. Change the logic for gitrev as follows - if the source tree is a git repository, the behavior for build is unchanged. For make dist, append -dist to the git tag in the distributed version of zfs_gitrev.h. - otherwise, check if the source tree contains zfs_gitrev.h, and use it if so, falling back to "unknown" if it doesn't exist. - clean it only in make maintainer-clean, so we don't remove it from the source tree on make clean or make distclean. This allows disted sources to track what git tag they originally came from, with the -dist suffix indicating that the code wasn't built directly from git and so might contain additional changes beyond the git tag. Reviewed-by: Brian Behlendorf <[email protected]> Reviewed-by: Eli Schwartz <[email protected]> Signed-off-by: Arvind Sankar <[email protected]> Closes #10595
-rw-r--r--Makefile.am5
-rwxr-xr-xscripts/make_gitrev.sh30
2 files changed, 33 insertions, 2 deletions
diff --git a/Makefile.am b/Makefile.am
index 98cf55880..96ff7d860 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -50,7 +50,6 @@ EXTRA_DIST += module/zfs/THIRDPARTYLICENSE.cityhash.descrip
@CODE_COVERAGE_RULES@
GITREV = include/zfs_gitrev.h
-CLEANFILES = $(GITREV)
PHONY = gitrev
gitrev:
@@ -59,6 +58,9 @@ gitrev:
all: gitrev
# Double-colon rules are allowed; there are multiple independent definitions.
+maintainer-clean-local::
+ -$(RM) $(GITREV)
+
distclean-local::
-$(RM) -R autom4te*.cache build
-find . \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS \
@@ -76,6 +78,7 @@ all-local:
${top_builddir}/scripts/zfs-tests.sh -c
dist-hook:
+ $(AM_V_GEN)$(top_srcdir)/scripts/make_gitrev.sh -D $(distdir) $(GITREV)
$(SED) ${ac_inplace} -e 's/Release:[[:print:]]*/Release: $(RELEASE)/' \
$(distdir)/META
diff --git a/scripts/make_gitrev.sh b/scripts/make_gitrev.sh
index 8db4de931..f5c743b13 100755
--- a/scripts/make_gitrev.sh
+++ b/scripts/make_gitrev.sh
@@ -27,10 +27,21 @@
set -e -u
+dist=no
+distdir=.
+while getopts D: flag
+do
+ case $flag in
+ \?) echo "Usage: $0 [-D distdir] [file]" >&2; exit 1;;
+ D) dist=yes; distdir=${OPTARG};;
+ esac
+done
+shift $((OPTIND - 1))
+
top_srcdir="$(dirname "$0")/.."
GITREV="${1:-include/zfs_gitrev.h}"
-# GITREV should be a relative path (relative to top_builddir)
+# GITREV should be a relative path (relative to top_builddir or distdir)
case "${GITREV}" in
/*) echo "Error: ${GITREV} should be a relative path" >&2
exit 1;;
@@ -38,10 +49,27 @@ esac
ZFS_GITREV=$({ cd "${top_srcdir}" &&
git describe --always --long --dirty 2>/dev/null; } || :)
+
+if [ "x${ZFS_GITREV}" = x ]
+then
+ # If the source directory is not a git repository, check if the file
+ # already exists (in the source)
+ if [ -f "${top_srcdir}/${GITREV}" ]
+ then
+ ZFS_GITREV="$(sed -n \
+ '1s/^#define[[:blank:]]ZFS_META_GITREV "\([^"]*\)"$/\1/p' \
+ "${top_srcdir}/${GITREV}")"
+ fi
+elif [ ${dist} = yes ]
+then
+ # Append -dist when creating distributed sources from a git repository
+ ZFS_GITREV="${ZFS_GITREV}-dist"
+fi
ZFS_GITREV=${ZFS_GITREV:-unknown}
GITREVTMP="${GITREV}~"
printf '#define\tZFS_META_GITREV "%s"\n' "${ZFS_GITREV}" >"${GITREVTMP}"
+GITREV="${distdir}/${GITREV}"
if cmp -s "${GITREV}" "${GITREVTMP}"
then
rm -f "${GITREVTMP}"